package io.zipcoder;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class ItemPrinter {

    ItemParser parser = new ItemParser();
    ArrayList<Item> itemsArray = new ArrayList<>();

    public String prettyPrint(String rawData) {
        ArrayList<String> itemStrings = parser.parseRawDataIntoStringArray(rawData);
        for (String s : itemStrings) {
            Item item = parser.parseStringIntoItem(s);
            if (item != null) {
                itemsArray.add(item);
            }
        }

        Map<String, Map<Double, List<Item>>> itemsMap = parser.getItemsMap(itemsArray);

        StringBuilder output = new StringBuilder();
        itemsMap.forEach(
                (str,value) -> {
                    int itemCount = getItemCount(value);
                    output.append(
                            String.format("name: %7s     seen: %d times", str, itemCount)
                            + ("\n") + ("=============     =============") + ("\n")
                    );
                    for (Map.Entry<Double, List<Item>> entry : value.entrySet()) {
                        output.append(
                                String.format("price: $%5.2f     seen: %d times", entry.getKey(), entry.getValue().size())
                                        + ("\n") + ("-------------     -------------") + ("\n")
                        );
                    }
                    output.append("\n");
                }
                );
        return output.toString();
    }

    private int getItemCount(Map<Double, List<Item>> value) {
        int itemCount = 0;
        for (Map.Entry<Double, List<Item>> entry : value.entrySet()) {
            Double price = entry.getKey();
            List<Item> itemArray = entry.getValue();
            itemCount += itemArray.size();
        }
        return itemCount;
    }

}
